#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

#include "debug.h"

static char debugname[256];


void printd ( const char *fmt, ... )
{
	FILE *file;
	va_list ap;
	char s[1024];

	if (debugname[0]=='\0')
	{	return;
	}

	file= fopen(debugname, "a");

	if (!file)
	{	return;
	}

	s[0]= '\0';
	va_start(ap, fmt);
	vsprintf(s, fmt, ap);
	va_end(ap);


    fprintf(file, "%s\n", s);

    fclose(file);

}

void init_debug ( const char *f )
{
	FILE *file;

    debugname[0]= '\0';

	file= fopen(f, "w");
	if (!file)
	{	return;
	}

    strcpy(debugname, f);

    fclose (file);
}
